UNIT mTFeld;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mtobjekt, graphics, extctrls, Windows, mThilfstypen, dialogs, Sysutils,
     mtitem, mthindernis, inifiles, Forms;

type
   TFeld = CLASS

     // weitere Attribute
     private
        hatFeld : array of array of TFeldPunkt;
        FeldBreite : Integer;
        FeldTiefe : Integer;
        RoboterBlickRichtung : Integer;
        RoboterXPosition : Integer;
        RoboterYPosition : Integer;
        FeldPunktBreite : Real;
        FeldPunktTiefe : Real;
        kenntImage : TImage;

     //Objektbeziehungen:
        // hatTObjekt (0..Breite * Tiefe) of TObjekt;
        // kenntTBender () of TBender;

     // weitere Methoden
     private
        procedure zeichneObjekteAnPosition (pXPosition: Integer; pYPosition: Integer);
     public
        constructor init (pKenntImage: TImage); virtual;
        procedure entferneObjekteAnPosition (pXKoordinate: Integer; pYKoordinate: Integer);
        procedure erstelleFeld (pBreite: Integer; pTiefe: Integer; pRoboterStartXPosition: Integer; pRoboterStartYPosition: Integer; pItemAnzahl: Integer; pHindernisAnzahl: Integer);
        procedure erstelleHindernisAnPosition (pXKoordinate: Integer; pYKoordinate: Integer);
        procedure erstelleItemAnPosition (pXKoordinate: Integer; pYKoordinate: Integer);
        procedure LadeFeld (pFileName: String); virtual;
        procedure setzeFeldPunktAnRoboterPosition(pNeuerFeldPunkt: TFeldPunkt);
        procedure SetzeRoboterBlickRichtung (pRoboterBlickRichtung: Integer); virtual;
        procedure SetzeRoboterXPosition (pRoboterXPosition: Integer); virtual;
        procedure SetzeRoboterYPosition (pRoboterYPosition: Integer); virtual;
        procedure SpeichereFeld (pFileName: String); virtual;
        procedure zeichneDich; virtual;
        function GibFeldBreite : Integer; virtual;
        function gibFeldPunktAnRoboterPosition : TFeldPunkt;
        function gibFeldPunktAnPosition (pXPosition, pYPosition : Integer): TFeldPunkt;
        function GibFeldPunktBreite : Real; virtual;
        function GibFeldPunktTiefe : Real; virtual;
        function GibFeldTiefe : Integer; virtual;
        function GibFeldXPositionVonXKoordinate (pXKoordinate: Integer) : Integer;
        function GibFeldYPositionVonYKoordinate (pYKoordinate: Integer) : Integer;
        function GibRoboterBlickRichtung : Integer; virtual;
        function GibRoboterXPosition : Integer; virtual;
        function GibRoboterYPosition : Integer; virtual;
        function GibXKoordinateVonFeldXPosition (pFeldXPosition: Integer) : Real;
        function GibYKoordinateVonFeldYPosition (pFeldYPosition: Integer) : Real;

   end;

implementation

//+---------------------------------------------------------------------
//|         TFeld: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichneObjekteAnPosition (private) --------------------------
procedure TFeld.zeichneObjekteAnPosition (pXPosition: Integer; pYPosition: Integer);
const AnzahlProSeite = 2;
var
  startXKoordinate, startYKoordinate : Real;
  tmpXKoordinate, tmpYKoordinate : Real;
  ItemXAbstand, ItemYAbstand : Real;
  tmpXAbstand, tmpYAbstand : Real;
  loop : Integer;
  PositionLinks, PositionOben : Integer;
begin
  if length(hatFeld[pXPosition][pYPosition]) > 0 then
  begin
    startXKoordinate := GibXKoordinateVonFeldXPosition(pXPosition);
    startYKoordinate := GibYKoordinateVonFeldYPosition(pYPosition);
    ItemXAbstand := FeldPunktBreite / AnzahlProSeite;
    ItemYAbstand := FeldPunktTiefe / AnzahlProSeite;

    for loop := 0 to length(hatFeld[pXPosition][pYPosition]) - 1 do
    begin
      if hatFeld[pXPosition][pYPosition][loop] is TItem then
      begin
        //Wenn das Objekt am Indes loop ein Item ist
        PositionOben := (loop) div AnzahlProSeite;  //Y-Position innerhalb des Feldpunktes
        PositionLinks := (loop) mod AnzahlProSeite; //X-Position innerhalb des Feldpunktes
        if (PositionOben < AnzahlProSeite) and (PositionLinks < AnzahlProSeite) then
        begin
          tmpXKoordinate := startXKoordinate + (PositionLinks * ItemXAbstand + (ItemXAbstand / 2));
          tmpYKoordinate := startYKoordinate + (PositionOben * ItemYAbstand + (ItemYAbstand / 2));
          hatFeld[pXPosition][pYPosition][loop].zeichneDich(Round(tmpXKoordinate - (ItemXAbstand / 2) + 2),
                                                            Round(tmpYKoordinate - (ItemYAbstand / 2) + 2),
                                                            Round(tmpXKoordinate + (ItemXAbstand / 2) - 2),
                                                            Round(tmpYKoordinate + (ItemYAbstand / 2) - 2));
        end;
      end
      else
      begin
        hatFeld[pXPosition][pYPosition][loop].zeichneDich(Round(startXKoordinate + 2),
                                                          Round(startYKoordinate + 2),
                                                          Round(startXKoordinate + FeldPunktBreite - 1),
                                                          Round(startYKoordinate + FeldPunktTiefe - 1));
      end;


    end;
  end;
end;

//-------- init (public) -----------------------------------------------
constructor TFeld.init (pKenntImage: TImage);
begin
  kenntImage := pkenntImage;
  kenntImage.Canvas.Pen.Color := clBlack;
  kenntImage.Canvas.Brush.Color := clWhite;

  randomize;
end;

//-------- erstelleFeld (public) ---------------------------------------
procedure TFeld.erstelleFeld (pBreite: Integer; pTiefe: Integer; pRoboterStartXPosition: Integer; pRoboterStartYPosition: Integer; pItemAnzahl: Integer; pHindernisAnzahl: Integer);
var
  loopX, loopY : Integer;
  tmpXPosition, tmpYPosition : Integer;
begin
  FeldTiefe := pTiefe;
  FeldBreite := pBreite;
  FeldPunktTiefe := kenntImage.Height / FeldTiefe;
  FeldPunktBreite := kenntImage.Width / FeldBreite;

  RoboterXPosition := pRoboterStartXPosition;
  RoboterYPosition := pRoboterStartYPosition;
  RoboterBlickRichtung := 0;


  SetLength(hatFeld,FeldBreite);
  for loopX := 0 to FeldBreite - 1 do
  begin
    SetLength(hatFeld[loopX],FeldTiefe);
    for loopY := 0 to FeldTiefe - 1
      do SetLength(hatFeld[loopX][loopY],0);
  end;

  //--Items erstellen--
  while pItemAnzahl <> 0 do
  begin
    tmpXPosition := Random(feldBreite);
    tmpYPosition := Random(feldTiefe);
    if ((tmpXPosition <> pRoboterStartXPosition) or (tmpYPosition <> pRoboterStartYPosition)) then
    begin
      SetLength(hatFeld[tmpXPosition][tmpYPosition], length(hatFeld[tmpXPosition][tmpYPosition]) + 1);
      hatFeld[tmpXPosition][tmpYPosition][length(hatFeld[tmpXPosition][tmpYPosition]) - 1] := TItem.init(kenntImage.canvas);
      pItemAnzahl := pItemAnzahl - 1;
    end;
  end;
  //--Items erstellen--

  //--Hindernisse erstellen--
  while pHindernisAnzahl <> 0 do
  begin
    tmpXPosition := Random(feldBreite);
    tmpYPosition := Random(feldTiefe);
    if (length(hatFeld[tmpXPosition][tmpYPosition]) = 0) and ((tmpXPosition <> pRoboterStartXPosition) or (tmpYPosition <> pRoboterStartYPosition)) then
    begin
      SetLength(hatFeld[tmpXPosition][tmpYPosition], length(hatFeld[tmpXPosition][tmpYPosition]) + 1);
      hatFeld[tmpXPosition][tmpYPosition][length(hatFeld[tmpXPosition][tmpYPosition]) - 1] := THindernis.init(kenntImage.canvas);
      pHindernisAnzahl := pHindernisAnzahl - 1;
    end;
  end;
  //--Hindernisse  erstellen--

  zeichneDich;
end;

//-------- entferneObjekteAnPosition (public) --------------------------
procedure TFeld.entferneObjekteAnPosition (pXKoordinate: Integer; pYKoordinate: Integer);
var
  FeldXPosition, FeldYPosition : Integer;
  loop : Integer;
begin
  FeldXPosition := self.GibFeldXPositionVonXKoordinate(pXKoordinate);
  FeldYPosition := self.GibFeldYPositionVonYKoordinate(pYKoordinate);

  if length(hatFeld[FeldXPosition][FeldYPosition]) > 0 then
  begin
    hatFeld[FeldXPosition][FeldYPosition][length(hatFeld[FeldXPosition][FeldYPosition]) - 1].gibFrei;
    hatFeld[FeldXPosition][FeldYPosition][length(hatFeld[FeldXPosition][FeldYPosition]) - 1] := NIL;
    SetLength(hatFeld[FeldXPosition][FeldYPosition], length(hatFeld[FeldXPosition][FeldYPosition]) - 1);
    zeichneDich;
  end;
end;

//-------- erstelleHindernisAnPosition (public) ------------------------
procedure TFeld.erstelleHindernisAnPosition (pXKoordinate: Integer; pYKoordinate: Integer);
var
  FeldXPosition, FeldYPosition : Integer;
  loop : Integer;
begin
  FeldXPosition := self.GibFeldXPositionVonXKoordinate(pXKoordinate);
  FeldYPosition := self.GibFeldYPositionVonYKoordinate(pYKoordinate);

  if (length(hatFeld[FeldXPosition][FeldYPosition]) = 0) and ((FeldXPosition <> RoboterXPosition) or (FeldYPosition <> RoboterYPosition)) then
  begin
    SetLength(hatFeld[FeldXPosition][FeldYPosition], 1);
    hatFeld[FeldXPosition][FeldYPosition][0] := THindernis.init(kenntimage.canvas);
    zeichneDich;
  end;
end;

//-------- erstelleItemAnPosition (public) -----------------------------
procedure TFeld.erstelleItemAnPosition (pXKoordinate: Integer; pYKoordinate: Integer);
var
  FeldXPosition, FeldYPosition : Integer;
  loop : Integer;
begin
  FeldXPosition := self.GibFeldXPositionVonXKoordinate(pXKoordinate);
  FeldYPosition := self.GibFeldYPositionVonYKoordinate(pYKoordinate);

  if length(hatFeld[FeldXPosition][FeldYPosition]) > 0 then
  begin
    if not (hatFeld[FeldXPosition][FeldYPosition][0] is THindernis) then
    begin
      SetLength(hatFeld[FeldXPosition][FeldYPosition], length(hatFeld[FeldXPosition][FeldYPosition]) + 1);
      hatFeld[FeldXPosition][FeldYPosition][length(hatFeld[FeldXPosition][FeldYPosition]) - 1] := TItem.init(kenntimage.canvas)
    end;
  end
  else
  begin
    SetLength(hatFeld[FeldXPosition][FeldYPosition], 1);
    hatFeld[FeldXPosition][FeldYPosition][0] := TItem.init(kenntimage.canvas)
  end;

  zeichneDich;
end;

//-------- LadeFeld (public) -------------------------------------------
procedure TFeld.LadeFeld (pFileName: String);
var
  EingabeDatei : TInifile;
  loop, loopX, loopY : Integer;
  datenVonPosition : Integer;
begin
  EingabeDatei := TInifile.Create(pFileName);

  FeldTiefe := StrToInt(EingabeDatei.ReadString('main','tiefe','1'));
  FeldBreite := StrToInt(EingabeDatei.ReadString('main','breite','1'));
  FeldPunktTiefe := kenntImage.Height / FeldTiefe;
  FeldPunktBreite := kenntImage.Width / FeldBreite;

  SetLength(hatFeld,FeldBreite);
  for loopX := 0 to FeldBreite - 1 do
  begin
    SetLength(hatFeld[loopX],FeldTiefe);
    for loopY := 0 to FeldTiefe - 1
      do SetLength(hatFeld[loopX][loopY],0);
  end;  

  RoboterXPosition := StrToInt(EingabeDatei.ReadString('roboter','x','0'));
  RoboterYPosition := StrToInt(EingabeDatei.ReadString('roboter','y','0'));
  RoboterBlickRichtung := StrToInt(EingabeDatei.ReadString('roboter','winkel','0'));

  for loopX := 0 to FeldBreite - 1 do
  begin
    for loopY := 0 to FeldTiefe - 1 do
    begin
      datenVonPosition := StrToInt(EingabeDatei.ReadString(IntToStr(loopx),IntToStr(loopy),'0'));
      if datenVonPosition <> 0 then
      begin
        if datenVonPosition = -1 then
        begin
          SetLength(HatFeld[loopx][loopy],1);
          HatFeld[loopx][loopy][0] := THindernis.init(kenntImage.canvas);
        end
        else
        begin
          SetLength(HatFeld[loopx][loopy],datenVonPosition);
          for loop := 0 to length(HatFeld[loopx][loopy]) - 1
            do HatFeld[loopx][loopy][loop] := TItem.init(kenntImage.canvas);
        end;
      end;
    end;
  end;

  EingabeDatei.free;

  zeichneDich;
end;

//-------- setzeFeldPunkt (public) -------------------------------------
procedure TFeld.setzeFeldPunktAnRoboterPosition (pNeuerFeldPunkt: TFeldPunkt);
begin
  if (RoboterXPosition >= 0) and
     (RoboterYPosition >= 0) and
     (RoboterXPosition < feldbreite) and
     (RoboterYPosition < feldtiefe) then
  begin
    hatFeld[RoboterXPosition][RoboterYPosition] := pNeuerFeldPunkt;
  end;
end;

//-------- SetzeRoboterBlickRichtung (public) --------------------------
procedure TFeld.SetzeRoboterBlickRichtung (pRoboterBlickRichtung: Integer);
   begin
      RoboterBlickRichtung := pRoboterBlickRichtung
   end;

//-------- SetzeRoboterXPosition (public) ------------------------------
procedure TFeld.SetzeRoboterXPosition (pRoboterXPosition: Integer);
   begin
      RoboterXPosition := pRoboterXPosition
   end;

//-------- SetzeRoboterYPosition (public) ------------------------------
procedure TFeld.SetzeRoboterYPosition (pRoboterYPosition: Integer);
   begin
      RoboterYPosition := pRoboterYPosition
   end;

//-------- SpeichereFeld (public) --------------------------------------
procedure TFeld.SpeichereFeld (pFileName: String);
var
  AusgabeDatei : TInifile;
  loopX, loopY : Integer;
begin
  AusgabeDatei := TInifile.Create(pFileName);

  AusgabeDatei.WriteString('main','breite',IntToStr(FeldBreite));
  AusgabeDatei.WriteString('main','tiefe',IntToStr(FeldTiefe));
  AusgabeDatei.WriteString('roboter','x',IntToStr(RoboterXPosition));
  AusgabeDatei.WriteString('roboter','y',IntToStr(RoboterYPosition));
  AusgabeDatei.WriteString('roboter','winkel',IntToStr(RoboterBlickRichtung));

  for loopX := 0 to FeldBreite - 1 do
  begin
    for loopY := 0 to FeldTiefe - 1 do
    begin
      if length(hatFeld[loopx][loopy]) > 0
      then
      begin
        if hatFeld[loopx][loopy][0] is THindernis
          then AusgabeDatei.WriteString(inttostr(loopx),inttostr(loopy),'-1')
          else AusgabeDatei.WriteString(inttostr(loopx),inttostr(loopy),IntToStr(length(hatFeld[loopx][loopy])));
      end
        else AusgabeDatei.WriteString(inttostr(loopx),inttostr(loopy),'0');
    end;
  end;

  AusgabeDatei.free;
end;

//-------- zeichneDich (public) ----------------------------------------
procedure TFeld.zeichneDich;
var
  loopX, loopY : Integer;
begin
  kenntImage.Canvas.Pen.Color := clBlack;
  kenntImage.Canvas.Brush.Color := clWhite;
  kenntImage.Canvas.Rectangle(0,0,kenntImage.width,kenntImage.Height);  //lschen

  for loopX := 0 to FeldBreite - 1 do
  begin
    kenntImage.Canvas.moveto(Round(GibXKoordinateVonFeldXPosition(loopx)), 0);
    kenntImage.Canvas.lineto(Round(GibXKoordinateVonFeldXPosition(loopx)), kenntImage.Height);
  end;

  for loopY := 0 to FeldTiefe - 1 do
  begin
    kenntImage.Canvas.moveto(0,Round(GibYKoordinateVonFeldYPosition(loopy)));
    kenntImage.Canvas.lineto(kenntImage.Width, Round(GibYKoordinateVonFeldYPosition(loopy)));
  end;

  for loopX := 0 to FeldBreite - 1
    do for loopY := 0 to FeldTiefe - 1
      do zeichneObjekteAnPosition(loopX, loopY);
end;

//-------- GibFeldBreite (public) --------------------------------------
function TFeld.GibFeldBreite : Integer;
begin
  result  := FeldBreite
end;

//-------- gibFeldPunkt (public) ---------------------------------------
function TFeld.gibFeldPunktAnRoboterPosition : TFeldPunkt;
begin
  result := NIL;
  if (RoboterXPosition >= 0) and
     (RoboterYPosition >= 0) and
     (RoboterXPosition < feldbreite) and
     (RoboterYPosition < feldtiefe) then
  begin
    result := hatFeld[RoboterXPosition][RoboterYPosition];
  end;
end;

//-------- GibFeldPunktBreite (public) ---------------------------------
function TFeld.GibFeldPunktBreite : Real;
begin
  result  := FeldPunktBreite
end;

//-------- GibFeldPunktTiefe (public) ----------------------------------
function TFeld.GibFeldPunktTiefe : Real;
begin
  result  := FeldPunktTiefe
end;

//-------- GibFeldTiefe (public) ---------------------------------------
function TFeld.GibFeldTiefe : Integer;
begin
  result  := FeldTiefe
end;

//-------- GibFeldXPositionVonXKoordinate (public) ---------------------
function TFeld.GibFeldXPositionVonXKoordinate (pXKoordinate: Integer) : Integer;
begin
  result := pXKoordinate div Round(FeldPunktBreite);
  if result = FeldBreite
    then result := result - 1;
end;

//-------- GibFeldYPositionVonYKoordinate (public) ---------------------
function TFeld.GibFeldYPositionVonYKoordinate (pYKoordinate: Integer) : Integer;
begin
  result := pYKoordinate div Round(FeldPunktTiefe);
  if result = FeldTiefe
    then result := result - 1;

end;

//-------- GibRoboterBlickRichtung (public) ----------------------------
function TFeld.GibRoboterBlickRichtung : Integer;
   begin
      result  := RoboterBlickRichtung
   end;

//-------- GibRoboterXPosition (public) --------------------------------
function TFeld.GibRoboterXPosition : Integer;
   begin
      result  := RoboterXPosition
   end;

//-------- GibRoboterYPosition (public) --------------------------------
function TFeld.GibRoboterYPosition : Integer;
   begin
      result  := RoboterYPosition
   end;

//-------- GibXKoordinateVonFeldXPosition (public) ---------------------
function TFeld.GibXKoordinateVonFeldXPosition (pFeldXPosition: Integer) : Real;
begin
  result := pFeldXPosition * self.FeldPunktBreite;
end;

//-------- GibYKoordinateVonFeldYPosition (public) ---------------------
function TFeld.GibYKoordinateVonFeldYPosition (pFeldYPosition: Integer) : Real;
begin
  result := pFeldYPosition * self.FeldPunktTiefe;
end;

function TFeld.gibFeldPunktAnPosition (pXPosition, pYPosition : Integer): TFeldPunkt;
begin
  result := NIL;
  if (pXposition >= 0) and
     (pYposition >= 0) and
     (pXposition < feldbreite) and
     (pYposition < feldtiefe) then
  begin
    result := hatFeld[pXPosition][pYPosition];
  end;

end;

end.
