UNIT mTInterpreter;

interface

//--------------------  ggf Uses-Liste einfgen !  --------------------
uses mtBender, mthilfstypen, dialogs;

type
   TInterpreter = CLASS

     // weitere Attribute
     private
        zeilenWeiseAusfuehren : Boolean;
        kenntBender : TBender;

     // weitere Methoden
     private
        procedure fuehreBefehlAus (pBefehl: String); virtual;
        procedure fuehreSolangeWieAus (pBedingung: TTokenliste; pTueBefehle: TTokenliste); virtual;
        procedure fuehreWennAus (pBedingung: TTokenListe; pDannBefehle: TTokenliste; pSonstBefehle: TTokenliste); virtual;
        function gibErgebnissVonAnfrage (pAnfrage: String) : Boolean; virtual;

        function gibTokenlisteBisKlammerZu (pTokenListe: TTokenliste; pStartPosition : Integer; var endPosition : Integer) : TTokenliste; virtual;
        function TokenListeToString(pTokenListe : TTokenListe) : String;

        function BedingungErfuellt(pBedingung: TTokenListe) : Boolean;
     public
        constructor init (pBender: TBender); virtual;
        procedure fuehreTokenlisteAus (pTokenListe: TTokenliste); virtual;
        procedure SetzeZeilenWeiseAusfuehren (pZeilenWeiseAusfuehren: Boolean); virtual;
        destructor gibFrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TInterpreter: Methodendefinition
//+---------------------------------------------------------------------

//-------- fuehreTokenlisteAus (public) --------------------------------
procedure TInterpreter.fuehreTokenlisteAus (pTokenListe: TTokenliste);
var
  position : Integer;
  Befehl, BefehlsTyp : String;
  Bedingung, TueBefehle, DannBefehle, SonstBefehle: TTokenliste;
begin
  position := 0;
//  if self.zeilenWeiseAusfuehren
//    then MessageDlgPos('Fhre folgende Tokenliste aus:' + #13#10 + TokenListeToString(pTokenListe), mtInformation,[mbOk], 0);

  while position <> Length(pTokenListe) do
  begin
    Befehl := pTokenListe[position][2];
    BefehlsTyp := pTokenListe[position][1];

    //--Befehl--
    if BefehlsTyp = 'befehl'
      then fuehreBefehlAus(befehl)

    //--SolangeWie-Anweisung--
    else if Befehl = 'solangewie' then
    begin
      if pTokenListe[position + 1][2] = 'not' then
      begin
        SetLength(Bedingung,2);
        Bedingung[0][2] := 'not';
        Bedingung[1][2] := pTokenListe[position + 2][2];
        TueBefehle := self.gibTokenlisteBisKlammerZu(pTokenListe,position + 4, position);
      end
      else
      begin
        SetLength(Bedingung,1);
        Bedingung[0][2] := pTokenListe[position + 1][2];
        TueBefehle := self.gibTokenlisteBisKlammerZu(pTokenListe,position + 3, position);
      end;
      fuehreSolangeWieAus(Bedingung,tueBefehle);
    end

    //--Wenn-Dann-Anweisung--
    else if Befehl = 'wenn' then
    begin
      if pTokenListe[position + 1][2] = 'not' then
      begin
        SetLength(Bedingung,2);
        Bedingung[0][2] := 'not';
        Bedingung[1][2] := pTokenListe[position + 2][2];
        DannBefehle := self.gibTokenlisteBisKlammerZu(pTokenListe,position + 4, position);
      end
      else
      begin
        SetLength(Bedingung,1);
        Bedingung[0][2] := pTokenListe[position + 1][2];
        DannBefehle := self.gibTokenlisteBisKlammerZu(pTokenListe,position + 3, position);
      end;

      SetLength(SonstBefehle,0);
      if position + 1 < length(pTokenListe) then
      begin
        if pTokenListe[position + 1][2] = 'sonst'
          then SonstBefehle := self.gibTokenlisteBisKlammerZu(pTokenListe,position + 2, position);
      end;

      fuehreWennAus(Bedingung,DannBefehle,sonstBefehle);
    end;

    position := position + 1;
  end;

end;

//-------- gibTokenlisteBisKlammerZu (private) -------------------------
function TInterpreter.gibTokenlisteBisKlammerZu (pTokenListe: TTokenliste; pStartPosition : Integer; var endPosition : Integer) : TTokenliste;
var
  KlammerAuf, KlammerZu : Integer;
  position : Integer;
begin
  setLength(result,0);
  endPosition := pStartPosition;
  KlammerAuf := 0;
  KlammerZu := 0;
  position := pStartPosition;
  if pTokenliste[position][2] = #123 then
  begin
    KlammerAuf := 1;
    position := pStartPosition + 1;
    while KlammerAuf <> KlammerZu do
    begin
      setlength(result, length(result) + 1);
      result[length(result) - 1][2] := pTokenListe[position][2];
      result[length(result) - 1][1] := pTokenListe[position][1];
      if pTokenListe[position][2] = #123 //{
        then KlammerAuf := KlammerAuf + 1
        else if pTokenListe[position][2] = #125 //}
               then KlammerZu := KlammerZu + 1;
      position := position + 1;
    end;

    setlength(result, length(result) - 1);
    position := position - 1;
    endPosition := position;
  end;
end;

//-------- fuehreBefehlAus (private) -----------------------------------
procedure TInterpreter.fuehreBefehlAus (pBefehl: String);
begin
  if self.zeilenWeiseAusfuehren
    then MessageDlgPos('Fhre folgenden Befehl aus: "' + pBefehl + '"', mtInformation,[mbOk], 0, 0, 0);

  if pBefehl = 'vor'
    then kenntBender.vor
  else if pBefehl = 'drehe_links'
    then kenntBender.drehe_links
  else if pBefehl = 'drehe_rechts'
    then kenntBender.drehe_rechts
  else if pBefehl = 'nimm'
    then kenntBender.nimm
  else if pBefehl = 'gib'
    then kenntBender.gib;
end;

//-------- fuehreSolangeWieAus (private) --------------------------------
procedure TInterpreter.fuehreSolangeWieAus (pBedingung: TTokenliste; pTueBefehle: TTokenliste);
begin
  if zeilenWeiseAusfuehren
    then MessageDlgPos('Fhre folgenden SolangeWie-Befehl aus: ' + #13#10+
                    'Bedingung: ' + #13#10 + TokenListeToString(pBedingung) + #13#10 +
                    'Tue-Befehle: '+ #13#10 + TokenListeToString(pTueBefehle), mtInformation,[mbOk], 0, 0, 0);


  while BedingungErfuellt(pBedingung)
    do fuehreTokenlisteAus(pTueBefehle);

end;

function TInterpreter.BedingungErfuellt(pBedingung: TTokenListe) : Boolean;
var
  tmpString : String;
begin
  result := false;
  if length(pBedingung) = 2
    then result := (not gibErgebnissVonAnfrage(pBedingung[1][2]))
    else result := gibErgebnissVonAnfrage(pBedingung[0][2]);

  if zeilenWeiseAusfuehren then
  begin
    if result
      then MessageDlgPos('Die Bedingung:' + #13#10 + TokenListeToString(pBedingung) + 'ist erfllt.', mtInformation,[mbOk], 0, 0, 0)
      else MessageDlgPos('Die Bedingung:' + #13#10 + TokenListeToString(pBedingung) + 'ist nicht erfllt.', mtInformation,[mbOk], 0, 0, 0);
  end;
end;
//-------- fuehreWennAus (private) -------------------------------------
procedure TInterpreter.fuehreWennAus (pBedingung: TTokenListe; pDannBefehle: TTokenliste; pSonstBefehle: TTokenliste);
begin
  if zeilenWeiseAusfuehren
    then MessageDlgPos('Fhre folgenden wenn-dann-Befehl aus: ' + #13#10+
                    'Bedingung: ' + #13#10 + TokenListeToString(pBedingung) + #13#10 +
                    'Dann-Befehle: '+ #13#10 + TokenListeToString(pDannBefehle) + #13#10 +
                    'Sonst-Befehle: '+ #13#10 + TokenListeToString(pSonstBefehle), mtInformation,[mbOk], 0, 0, 0);

  if self.BedingungErfuellt(pBedingung)
    then fuehreTokenlisteAus(pDannBefehle)
    else fuehreTokenlisteAus(pSonstBefehle);
end;

//-------- gibErgebnissVonAnfrage (private) ----------------------------
function TInterpreter.gibErgebnissVonAnfrage (pAnfrage: String) : Boolean;
begin
  result := false;

  if pAnfrage = 'itemda'
    then result := kenntBender.itemda
  else if pAnfrage = 'vornefrei'
    then result := kenntBender.vorneFrei
  else if pAnfrage = 'itemsimrucksack'
    then result := kenntBender.itemsImRucksack
  else if pAnfrage = 'blicktnach_unten'    
    then result := kenntBender.SchautNachUnten
  else if pAnfrage = 'blicktnach_oben'
    then result := kenntBender.SchautNachOben
  else if pAnfrage = 'blicktnach_rechts'
    then result := kenntBender.SchautNachRechts
  else if pAnfrage = 'blicktnach_links'
    then result := kenntBender.SchautNachLinks;
    
end;

//-------- SetzeZeilenWeiseAusfuehren (public) -------------------------
procedure TInterpreter.SetzeZeilenWeiseAusfuehren (pZeilenWeiseAusfuehren: Boolean);
   begin
      zeilenWeiseAusfuehren := pZeilenWeiseAusfuehren
   end;

//-------- gibFrei (public) --------------------------------------------
destructor TInterpreter.gibFrei;
begin
  //Hier Code einfgen.
end;

//-------- init (public) -----------------------------------------------
constructor TInterpreter.init (pBender: TBender);
begin
  kenntBender := pBender;
  zeilenWeiseAusfuehren := true;
end;

function TInterpreter.TokenListeToString(pTokenListe : TTokenListe) : String;
var
  loop : Integer;
begin
  result := '';
  for loop := 0 to length(pTokenListe) - 1
    do result := result + pTokenListe[loop][2] + ' (' + pTokenListe[loop][1] + ')' + #13#10  ;
end;

end.
