UNIT mTParserAutomat;

interface

uses mthilfstypen;

type
  TZustand = (zStart, zNwenn, zNwennNot, zNwennAnfrage, zNDann, zNDannKA, zNDannKZ, zNSonst, zNsonstKZ, zNSonstKA, zNSolange, zNSolangeNot, zNSolangeAnfrage, zNTue, zNTueKA, zNTueKZ, zFehler);

type
   TParserAutomat = CLASS

     private
        aktuellerZustand : TZustand;
        startZustand : TZustand;
        fehlerZustand : TZustand;
        akzeptierteZustaende : Set of TZustand;
        function UebergangsFunktionF (pAktuellerZustand: TZustand; pEingabe: TToken) : TZustand;
        function AusgabeFunktionG (pAktuellerZustand: TZustand; pEingabe: TToken) : String;
     public
        constructor init;
        procedure setzeZurueck;
        function istInFehlerZustand : Boolean;
        function istInAkzeptiertemZustand : Boolean;
        function verarbeiteEingabe (pEingabe: TToken) : String;
        destructor gibFrei;

   end;

implementation

constructor TParserAutomat.init;
begin
  startZustand := zStart;
  fehlerZustand := zFehler;
  akzeptierteZustaende := [zStart, zNDannKZ, zNSonstKZ, zNTueKZ];
  setzeZurueck;
end;

function TParserAutomat.UebergangsFunktionF (pAktuellerZustand: TZustand; pEingabe: TToken) : TZustand;
begin
  result := FehlerZustand;

  case pAktuellerZustand of

    zStart : begin
      if pEingabe[1] = 'befehl'
        then result := zStart
      else if pEingabe[1] = 'anfrage'
        then result := zStart
      else if pEingabe[2] = 'wenn'
        then result := zNwenn
      else if pEingabe[2] = 'solangewie'
        then result := zNSolange

    end; //of pAktuellerZustand : zStart

    zNwenn : begin
      if pEingabe[2] = 'not'
        then result := zNwennNot
      else if pEingabe[1] = 'anfrage'
        then result := zNwennAnfrage

    end; //of pAktuellerZustand : zNwenn

    zNwennNot : begin
      if pEingabe[1] = 'anfrage'
        then result := zNwennAnfrage

    end; //of pAktuellerZustand : zNwennNot

    zNwennAnfrage : begin
      if pEingabe[2] = 'dann'
        then result := zNDann

    end; //of pAktuellerZustand : zNwennAnfrage

    zNDann : begin
      if pEingabe[2] = #123
        then result := zNDannKA

    end; //of pAktuellerZustand : zNDann

    zNDannKA : begin
      if pEingabe[1] = 'befehl'
        then result := zNDannKA
      else if pEingabe[1] = 'anfrage'
        then result := zNDannKA
      else if pEingabe[2] = #125
        then result := zNDannKZ

    end; //of pAktuellerZustand : zNDannKA

    zNDannKZ : begin
      if pEingabe[2] = 'sonst'
        then result := zNSonst
      else if pEingabe[1] = 'befehl'
        then result := zStart
      else if pEingabe[1] = 'anfrage'
        then result := zStart
      else if pEingabe[2] = 'wenn'
        then result := zNwenn
      else if pEingabe[2] = 'solangewie'
        then result := zNSolange

    end; //of pAktuellerZustand : zNDannKZ

    zNSonst : begin
      if pEingabe[2] = #123             
        then result := zNsonstKA

    end; //of pAktuellerZustand : zNSonst

    zNSonstKA : begin
      if pEingabe[2] = #125
        then result := zNSonstKZ
      else if pEingabe[1] = 'befehl'
        then result := zNsonstKA
      else if pEingabe[1] = 'anfrage'
        then result := zNsonstKA
    end; //of pAktuellerZustand : zNSonstKA

    zNsonstKZ : begin
      if pEingabe[1] = 'befehl'
        then result := zStart
      else if pEingabe[1] = 'anfrage'
        then result := zStart
      else if pEingabe[2] = 'wenn'
        then result := zNwenn
      else if pEingabe[2] = 'solangewie'
        then result := zNSolange

    end; //of pAktuellerZustand : zNsonstKZ

    zNSolange : begin
      if pEingabe[1] = 'anfrage'
        then result := zNSolangeAnfrage
      else if pEingabe[2] = 'not'
        then result := zNSolangeNot

    end; //of pAktuellerZustand : zNSolange

    zNSolangeNot : begin
      if pEingabe[1] = 'anfrage'
        then result := zNSolangeAnfrage

    end; //of pAktuellerZustand : zNSolangeNot

    zNSolangeAnfrage : begin
      if pEingabe[2] = 'tue'
        then result := zNTue

    end; //of pAktuellerZustand : zNSolangeAnfrage

    zNTue : begin
      if pEingabe[2] = #123 
        then result := zNTueKA

    end; //of pAktuellerZustand : zNTue

    zNTueKA : begin
      if pEingabe[2] = #125
        then result := zNTueKZ
      else if pEingabe[1] = 'befehl'
        then result := zNTueKA
      else if pEingabe[1] = 'anfrage'
        then result := zNTueKA

    end; //of pAktuellerZustand : zNTueKA

    zNTueKZ : begin
      if pEingabe[1] = 'befehl'
        then result := zStart
      else if pEingabe[1] = 'anfrage'
        then result := zStart
      else if pEingabe[2] = 'wenn'
        then result := zNwenn
      else if pEingabe[2] = 'solangewie'
        then result := zNSolange

    end; //of pAktuellerZustand : zNTueKZ


  end;
end;

function TParserAutomat.AusgabeFunktionG (pAktuellerZustand: TZustand; pEingabe: TToken) : String;
begin
  result := '';
  case pAktuellerZustand of

    zStart : begin
      if (pEingabe[2] = 'dann') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #123) or
         (pEingabe[2] = #125) or
         (pEingabe[2] = 'not')
        then result := pEingabe[2] + ' ist in diesem Kontext nicht erlaubt.'

    end; //of pAktuellerZustand : zStart

    zNwenn : begin
      if (pEingabe[1] = 'befehl') or
         (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'dann') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'solangewie') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #123) or
         (pEingabe[2] = #125)
        then result := 'Nur "not" oder eine Anfrage sind nach "Wenn" erlaubt.'

    end; //of pAktuellerZustand : zNwenn

    zNwennNot : begin
      if (pEingabe[1] = 'befehl') or
         (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'dann') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'solangewie') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #123) or
         (pEingabe[2] = #125) or
         (pEingabe[2] = 'not')
        then result := 'Nur eine Anfrage ist nach "not" erlaubt.'

    end; //of pAktuellerZustand : zNwennNot

    zNwennAnfrage : begin
      if (pEingabe[1] = 'befehl') or
         (pEingabe[1] = 'anfrage') or
         (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'solangewie') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #123) or
         (pEingabe[2] = #125) or
         (pEingabe[2] = 'not')
        then result := 'Nur "dann" ist nach der Bedingung erlaubt.'

    end; //of pAktuellerZustand : zNwennAnfrage

    zNDann : begin
      if (pEingabe[1] = 'befehl') or
         (pEingabe[1] = 'anfrage') or
         (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'dann') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'solangewie') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #125) or
         (pEingabe[2] = 'not')
        then result := 'Nur ' + #123 + ' ist nach "Dann" erlaubt.'

    end; //of pAktuellerZustand : zNDann

    zNDannKA : begin
      if (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'solangewie')
        then result := 'Verschachtelte Anweisungen sind noch nicht erlaubt.'
      else if (pEingabe[2] = 'dann') or
              (pEingabe[2] = 'sonst') or
              (pEingabe[2] = 'tue') or
              (pEingabe[2] = #123) or
              (pEingabe[2] = 'not')
        then result := 'Nur Befehle oder Anfragen sind nach "Dann" erlaubt.'

    end; //of pAktuellerZustand : zNDannKA

    zNDannKZ : begin
      if (pEingabe[2] = 'dann') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #123) or
         (pEingabe[2] = #125) or
         (pEingabe[2] = 'not')
        then result := pEingabe[2] + ' ist in diesem Kontext nicht erlaubt.'

    end; //of pAktuellerZustand : zNDannKZ

    zNSonst : begin
      if (pEingabe[1] = 'befehl') or
         (pEingabe[1] = 'anfrage') or
         (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'dann') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'solangewie') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #125) or
         (pEingabe[2] = 'not')
        then result := 'Nur ' + #123 + ' ist nach "Sonst" erlaubt.'

    end; //of pAktuellerZustand : zNSonst

    zNSonstKA : begin
      if (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'solangewie')
        then result := 'Verschachtelte Anweisungen sind noch nicht erlaubt.'
      else if (pEingabe[2] = 'dann') or
              (pEingabe[2] = 'sonst') or
              (pEingabe[2] = 'tue') or
              (pEingabe[2] = #123) or
              (pEingabe[2] = 'not')
        then result := 'Nur Befehle oder Anfragen sind nach "Sonst" erlaubt.'

    end; //of pAktuellerZustand : zNSonstKA

    zNsonstKZ : begin
      if (pEingabe[2] = 'dann') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #123) or
         (pEingabe[2] = #125) or
         (pEingabe[2] = 'not')
        then result := pEingabe[2] + ' ist in diesem Kontext nicht erlaubt.'

    end; //of pAktuellerZustand : zNsonstKZ

    zNSolange : begin
      if (pEingabe[1] = 'befehl') or
         (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'dann') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'solangewie') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #123) or
         (pEingabe[2] = #125)
        then result := 'Nur "not" oder eine Anfrage sind nach "Solangewie" erlaubt.'

    end; //of pAktuellerZustand : zNSolange

    zNSolangeNot : begin
      if (pEingabe[1] = 'befehl') or
         (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'dann') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'solangewie') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #123) or
         (pEingabe[2] = #125) or
         (pEingabe[2] = 'not')
        then result := 'Nur eine Anfrage ist nach "not" erlaubt.'


    end; //of pAktuellerZustand : zNSolangeNot

    zNSolangeAnfrage : begin
      if (pEingabe[1] = 'befehl') or
         (pEingabe[1] = 'anfrage') or
         (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'solangewie') or
         (pEingabe[2] = 'dann') or
         (pEingabe[2] = #123) or
         (pEingabe[2] = #125) or
         (pEingabe[2] = 'not')
        then result := 'Nur "tue" ist nach der Bedingung erlaubt.'

    end; //of pAktuellerZustand : zNSolangeAnfrage

    zNTue : begin
      if (pEingabe[1] = 'befehl') or
         (pEingabe[1] = 'anfrage') or
         (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'dann') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'solangewie') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #125) or
         (pEingabe[2] = 'not')
        then result := 'Nur ' + #123 + ' ist nach "Tue" erlaubt.'

    end; //of pAktuellerZustand : zNTue

    zNTueKA : begin
      if (pEingabe[2] = 'wenn') or
         (pEingabe[2] = 'solangewie')
        then result := 'Verschachtelte Anweisungen sind noch nicht erlaubt.'
      else if (pEingabe[2] = 'dann') or
              (pEingabe[2] = 'sonst') or
              (pEingabe[2] = 'tue') or
              (pEingabe[2] = #123) or
              (pEingabe[2] = 'not')
        then result := 'Nur Befehle oder Anfragen sind nach "Tue" erlaubt.'

    end; //of pAktuellerZustand : zNTueKA

    zNTueKZ : begin
      if (pEingabe[2] = 'dann') or
         (pEingabe[2] = 'sonst') or
         (pEingabe[2] = 'tue') or
         (pEingabe[2] = #123) or
         (pEingabe[2] = #125) or
         (pEingabe[2] = 'not')
        then result := pEingabe[2] + ' ist in diesem Kontext nicht erlaubt.'


    end; //of pAktuellerZustand : zNTueKZ


  end;
end;

procedure TParserAutomat.setzeZurueck;
begin
  aktuellerZustand := startZustand;
end;

function TParserAutomat.istInAkzeptiertemZustand : Boolean;
begin
  result := (aktuellerZustand in akzeptierteZustaende);
end;

function TParserAutomat.istInFehlerZustand : Boolean;
begin
  result := (aktuellerZustand = fehlerZustand);
end;

function TParserAutomat.verarbeiteEingabe (pEingabe: TToken) : String;
begin
  result := AusgabeFunktionG(aktuellerZustand, pEingabe);
  aktuellerZustand := UebergangsFunktionF(aktuellerZustand,pEingabe);
end;

destructor TParserAutomat.gibFrei;
begin
end;


end.
