

unit mTfmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, mtfeld, mtbender, mthilfstypen, Menus, mtscanner,
  ImgList, mtinterpreter, mtparser;

type
  TfmMain = class(TForm)
    mProgrammtext: TMemo;
    Label1: TLabel;
    imFeld: TImage;
    Label2: TLabel;
    gbStatus: TGroupBox;
    gbDirekteSteuerung: TGroupBox;
    bBenderVor: TButton;
    bBenderLinks: TButton;
    bBenderRechts: TButton;
    bBenderNimm: TButton;
    bBenderGib: TButton;
    Label3: TLabel;
    lbTokenListe: TListBox;
    cbvorneFrei: TCheckBox;
    lbXPos: TLabel;
    lbYPos: TLabel;
    lbBlickrichtung: TLabel;
    cbItemDa: TCheckBox;
    lbItems: TLabel;
    mMenue: TMainMenu;
    mgWelt: TMenuItem;
    mbWeltErstellen: TMenuItem;
    mgProgrammtext: TMenuItem;
    mbProgrammtextScannen: TMenuItem;
    imlSymbole: TImageList;
    mgDatei: TMenuItem;
    mbDateiLaden: TMenuItem;
    ProgrammtextSpeichern: TMenuItem;
    mbWeltSpeichern: TMenuItem;
    mbWeltLaden: TMenuItem;
    dlgWeltLaden: TOpenDialog;
    dlgWeltSpeichern: TSaveDialog;
    dlgTextSpeichern: TSaveDialog;
    dlgTextLaden: TOpenDialog;
    mbProgrammtextAusfuehren: TMenuItem;
    mbProgrammtextParsen: TMenuItem;
    cbZeilenweise: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure bBenderVorClick(Sender: TObject);
    procedure bBenderLinksClick(Sender: TObject);
    procedure bBenderRechtsClick(Sender: TObject);
    procedure bBenderNimmClick(Sender: TObject);
    procedure bBenderGibClick(Sender: TObject);
    procedure imFeldMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mbWeltErstellenClick(Sender: TObject);
    procedure mbProgrammtextScannenClick(Sender: TObject);
    procedure mbDateiLadenClick(Sender: TObject);
    procedure ProgrammtextSpeichernClick(Sender: TObject);
    procedure mbWeltSpeichernClick(Sender: TObject);
    procedure mbWeltLadenClick(Sender: TObject);
    procedure mbProgrammtextAusfuehrenClick(Sender: TObject);
    procedure mbProgrammtextParsenClick(Sender: TObject);
    procedure cbZeilenweiseClick(Sender: TObject);
  private
    hatFeld : TFeld;
    hatBender : TBender;
    hatTokenListe : TTokenListe;
    ProgrammtextFehlerfrei : Boolean;
    hatScanner : TScanner;
    hatInterpreter : TInterpreter;
    hatParser : TParser;
    procedure aktualisiereBenderInfos(pXPosition, pYPosition, pBlickRichtung, pItemsImRucksack : Integer; vorneFrei, itemDa : Boolean);
    procedure GibTokenListeAus;
  public
    { Public-Deklarationen }
  end;

var
  fmMain: TfmMain;

implementation

uses mTfmNeueWelt;

{$R *.DFM}

procedure TfmMain.aktualisiereBenderInfos(pXPosition, pYPosition, pBlickRichtung, pItemsImRucksack : Integer; vorneFrei, itemDa : Boolean);
begin
  lbXPos.Caption := 'X-Position: ' + IntToStr(pXPosition);
  lbYPos.Caption := 'Y-Position: ' + IntToStr(pYPosition);
  lbBlickrichtung.Caption := 'Blick Richtung: ' + IntToStr(pBlickRichtung);
  lbItems.Caption := 'Items im Rucksack: ' + IntToStr(pItemsImRucksack);

  cbvorneFrei.Checked := vorneFrei;
  cbitemDa.Checked := itemDa;
end;

procedure TfmMain.FormCreate(Sender: TObject);
begin
  hatFeld := TFeld.init(self.imFeld);
  hatFeld.erstelleFeld(10,10,0,0,20,6);

  hatBender := TBender.init(hatFeld,self.imFeld.canvas);
  hatBender.StatusGeandert := aktualisiereBenderInfos;
  hatBender.zeichneDich;

  SetLength(hatTokenListe,0);

  hatScanner := TScanner.init;
  hatParser := TParser.init;
  hatInterpreter := TInterpreter.init(hatBender);
end;

procedure TfmMain.bBenderVorClick(Sender: TObject);
begin
  hatBender.vor;
end;

procedure TfmMain.bBenderLinksClick(Sender: TObject);
begin
  hatBender.drehe_links;
end;

procedure TfmMain.bBenderRechtsClick(Sender: TObject);
begin
  hatBender.drehe_rechts;
end;

procedure TfmMain.bBenderNimmClick(Sender: TObject);
begin
  hatBender.nimm;
end;

procedure TfmMain.bBenderGibClick(Sender: TObject);
begin
  hatBender.gib;
end;

procedure TfmMain.imFeldMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  tmpFeldPunkt : TFeldPunkt;
begin
  if ssCtrl in Shift
    then hatFeld.entferneObjekteAnPosition(X, Y)
  else
  begin
    if Button = mbLeft
      then hatFeld.erstelleItemAnPosition(X, Y)
      else hatFeld.erstelleHindernisAnPosition(X, Y);
  end;
  hatBender.zeichneDich;
end;

procedure TfmMain.mbWeltErstellenClick(Sender: TObject);
begin
  if fmNeueWelt.showModal = mrOk then
  begin
    if (StrToInt(fmNeueWelt.eRoboterStartXPosition.text) < StrToInt(fmNeueWelt.eWeltBreite.text)) and
       (StrToInt(fmNeueWelt.eRoboterStartYPosition.text) < StrToInt(fmNeueWelt.eWeltTiefe.text)) and
       (StrToInt(fmNeueWelt.eRoboterStartXPosition.text) >= 0) and
       (StrToInt(fmNeueWelt.eRoboterStartYPosition.text) >= 0) then

    begin
      hatFeld.erstelleFeld(StrToInt(fmNeueWelt.eWeltBreite.text),
                           StrToInt(fmNeueWelt.eWeltTiefe.text),
                           StrToInt(fmNeueWelt.eRoboterStartXPosition.text),
                           StrToInt(fmNeueWelt.eRoboterStartYPosition.text),
                           StrToInt(fmNeueWelt.eItems.text),
                           StrToInt(fmNeueWelt.eHindernisse.text));
      hatBender.setzeZurueck;
      hatBender.zeichneDich;
    end
      else MessageDlg('Fehler!' + #13#10 + 'Der Roboter kann nicht auerhalb des Feldes starten!',mtError, [mbOk], 0);
  end;
end;

procedure TfmMain.mbProgrammtextScannenClick(Sender: TObject);
begin
  hatTokenListe := hatScanner.ScanneProgrammText(self.mProgrammtext.Text);
  GibTokenListeAus;

  ProgrammtextFehlerfrei := false;
  mbProgrammtextParsen.Enabled := true;
  mbProgrammtextAusfuehren.Enabled := true;
end;

procedure TfmMain.GibTokenListeAus;
var
  loop : Integer;
begin
  lbTokenListe.Items.Text := '';
  for loop := 0 to length(hatTokenListe) - 1
    do lbTokenListe.Items.add(hatTokenListe[loop][2] + ' (' + hatTokenListe[loop][1] + ')');
end;

procedure TfmMain.mbDateiLadenClick(Sender: TObject);
begin
  if dlgTextLaden.Execute
    then mProgrammtext.Lines.LoadFromFile(dlgTextLaden.FileName);
end;

procedure TfmMain.ProgrammtextSpeichernClick(Sender: TObject);
begin
  if dlgTextSpeichern.Execute then
  begin
    if fileExists(dlgTextSpeichern.FileName) then
    begin
      if MessageDlg('Warnung! Die ausgewhlte Datei exisitiert bereits.' + #13#10 + 'Soll sie berschrieben werden?', mtWarning, [mbYes, mbNo], 0) = mrNo
        then exit
        else deletefile(dlgTextSpeichern.filename);  //Wegen TInifile muss immer zuerst gelscht werden, da sonst nur ergnzt wird
    end;
    mProgrammtext.Lines.SaveToFile(dlgTextSpeichern.fileName);
  end;
end;


procedure TfmMain.mbWeltSpeichernClick(Sender: TObject);
begin
  if dlgWeltSpeichern.execute then
  begin
    if fileExists(dlgWeltSpeichern.FileName) then
    begin
      if MessageDlg('Warnung! Die ausgewhlte Datei exisitiert bereits.' + #13#10 + 'Soll sie berschrieben werden?', mtWarning, [mbYes, mbNo], 0) = mrNo
        then exit
        else deletefile(dlgWeltSpeichern.filename);  //Wegen TInifile muss immer zuerst gelscht werden, da sonst nur ergnzt wird

    end;
    hatFeld.SpeichereFeld(dlgWeltSpeichern.fileName);
  end;
end;

procedure TfmMain.mbWeltLadenClick(Sender: TObject);
begin
  if dlgWeltLaden.Execute then
  begin
    hatFeld.LadeFeld(dlgWeltLaden.filename);
    hatBender.setzeZurueck;
    hatBender.zeichneDich;
  end;
end;

procedure TfmMain.mbProgrammtextAusfuehrenClick(Sender: TObject);
begin
  if ProgrammtextFehlerfrei
    then hatInterpreter.fuehreTokenlisteAus(hatTokenListe)
  else
  begin
    if MessageDlg('Der Programmtext ist nicht mit Sicherheit fehlerfrei, trotzdem ausfhren?', mtWarning, [mbYes, mbNo], 0) = mrYes
      then hatInterpreter.fuehreTokenlisteAus(hatTokenListe)
  end;
end;

procedure TfmMain.mbProgrammtextParsenClick(Sender: TObject);
begin
  ProgrammtextFehlerfrei := hatParser.parseTokenliste(hatTokenListe);
end;

procedure TfmMain.cbZeilenweiseClick(Sender: TObject);
begin
  hatInterpreter.SetzeZeilenWeiseAusfuehren(cbZeilenweise.Checked);
end;

end.
