UNIT mTBender;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mTFeld, mtobjekt, graphics, mthindernis, dialogs, mtitem, math, 
     mthilfstypen;

type
   TBender = CLASS

     // weitere Attribute
     private
        hatRucksack : Array of TObjekt;
        kenntCanvas : TCanvas;
        kenntFeld : TFeld;
     public
        StatusGeandert : procedure ( pXPosition , pYPosition , pBlickRichtung , pItemsImRucksack : Integer ; vorneFrei , itemDa : Boolean ) of Object;

     // weitere Methoden
     public
        constructor init (pkenntFeld: TFeld; pKenntCanvas: TCanvas); virtual;
        procedure drehe_links; virtual;
        procedure drehe_rechts; virtual;
        procedure gib; virtual;
        procedure nimm; virtual;
        procedure setzeZurueck;
        procedure vor; virtual;
        procedure zeichneDich; virtual;
        function itemDa : Boolean; virtual;
        function itemsImRuckSack : Boolean; virtual;
        function SchautNachLinks : Boolean; virtual;
        function SchautNachOben : Boolean; virtual;
        function SchautNachRechts : Boolean; virtual;
        function SchautNachUnten : Boolean; virtual;
        function vorneFrei : Boolean; virtual;
        destructor gibFrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TBender: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TBender.init (pkenntFeld: TFeld; pKenntCanvas: TCanvas);
begin
  kenntFeld := pkenntFeld;
  kenntCanvas := pKenntCanvas;

  setzeZurueck;
end;

//-------- drehe_links (public) ----------------------------------------
procedure TBender.drehe_links;
var
  BlickRichtung : Integer;
begin
  kenntFeld.zeichneDich;

  BlickRichtung := kenntFeld.GibRoboterBlickRichtung;
  BlickRichtung := BlickRichtung + 90;
  if BlickRichtung = 360
    then BlickRichtung := BlickRichtung - 360;
  kenntFeld.SetzeRoboterBlickRichtung(BlickRichtung);

  zeichneDich;
end;

//-------- drehe_rechts (public) ---------------------------------------
procedure TBender.drehe_rechts;
var
  BlickRichtung : Integer;
begin
  kenntFeld.zeichneDich;

  BlickRichtung := kenntFeld.GibRoboterBlickRichtung;
  BlickRichtung := BlickRichtung - 90;
  if BlickRichtung = -90
    then BlickRichtung := BlickRichtung + 360;
  kenntFeld.SetzeRoboterBlickRichtung(BlickRichtung);

  zeichneDich;
end;

//-------- gib (public) ------------------------------------------------
procedure TBender.gib;
var
  tmpFeldPunkt : TFeldPunkt;
begin
  if length(hatRucksack) > 0 then
  begin
    tmpFeldPunkt := kenntFeld.gibFeldPunktAnRoboterPosition;

    SetLength(tmpFeldPunkt, length(tmpFeldPunkt) + 1);
    tmpFeldPunkt[length(tmpFeldPunkt) - 1] := hatRucksack[length(hatRucksack) - 1];
    hatRucksack[length(hatRucksack) - 1] := NIL;
    SetLength(hatRucksack, length(hatRucksack) - 1);

    kenntFeld.setzeFeldPunktAnRoboterPosition(tmpFeldPunkt);

    kenntFeld.zeichneDich;
    zeichneDich;
  end;
end;

//-------- nimm (public) -----------------------------------------------
procedure TBender.nimm;
var
  tmpFeldPunkt : TFeldPunkt;
begin
  if itemDa then
  begin
    tmpFeldPunkt := kenntFeld.gibFeldPunktAnRoboterPosition;

    setLength(hatRucksack, length(hatRucksack) + 1);
    hatRucksack[length(hatRucksack) - 1] := tmpFeldPunkt[length(tmpFeldPunkt) - 1];
    tmpFeldPunkt[length(tmpFeldPunkt) - 1] := NIL;    
    SetLength(tmpFeldPunkt, length(tmpFeldPunkt) - 1);

    kenntFeld.setzeFeldPunktAnRoboterPosition(tmpFeldPunkt);

    kenntFeld.zeichneDich;
    zeichneDich;
  end;
         
end;

//-------- setzeZurueck (public) ---------------------------------------
procedure TBender.setzeZurueck;
begin
  SetLength(hatRucksack,0);
end;

//-------- vor (public) ------------------------------------------------
procedure TBender.vor;
var
  XPosition, YPosition : Integer;
begin
  if vorneFrei then
  begin
    XPosition := kenntFeld.gibRoboterXPosition;
    YPosition := kenntFeld.gibRoboterYPosition;

    case kenntFeld.GibRoboterBlickRichtung of
      0: XPosition := XPosition + 1;
      180: XPosition := XPosition - 1;
      90: YPosition := YPosition - 1;
      270: YPosition := YPosition + 1
    end;

    kenntFeld.SetzeRoboterXPosition(XPosition);
    kenntFeld.SetzeRoboterYPosition(YPosition);

    kenntFeld.zeichneDich;
    zeichneDich;
  end;
end;

//-------- zeichneDich (public) ----------------------------------------
procedure TBender.zeichneDich;
var
  startXPosition, startYPosition : Real;
  zielXPosition, zielYPosition : Real;  
  RoboterXPosition, RoboterYPosition : Real;
begin
  RoboterXPosition := kenntFeld.GibXKoordinateVonFeldXPosition(kenntFeld.gibRoboterXPosition) + (kenntFeld.GibFeldPunktBreite / 2) + 1;
  RoboterYPosition := kenntFeld.GibYKoordinateVonFeldYPosition(kenntFeld.gibRoboterYPosition) + (kenntFeld.GibFeldPunktTiefe / 2) + 1;

  //--Krper--
  kenntCanvas.Pen.Color := clBlack;
  kenntCanvas.Brush.Color := clGray;

  kenntCanvas.ellipse(Round(RoboterXPosition - (kenntFeld.GibFeldPunktBreite / 4)),
                      Round(RoboterYPosition - (kenntFeld.GibFeldPunktTiefe / 4)),
                      Round(RoboterXPosition + (kenntFeld.GibFeldPunktBreite / 4)),
                      Round(RoboterYPosition + (kenntFeld.GibFeldPunktTiefe / 4)));
  //--Krper--

  //--Arme--
  kenntCanvas.Pen.Color := clmaroon;
  kenntCanvas.Pen.Width := 4;

  case kenntFeld.GibRoboterBlickRichtung of
    0: begin
      startXPosition := RoboterXPosition;
      startYPosition := RoboterYPosition - (kenntFeld.GibFeldPunktTiefe / 4);
      zielXPosition := startXPosition + (kenntFeld.GibFeldPunktBreite / 2.8);
      zielYPosition := startYPosition;
    end;

    180: begin
      startXPosition := RoboterXPosition;
      startYPosition := RoboterYPosition - (kenntFeld.GibFeldPunktTiefe / 4);
      zielXPosition := startXPosition - (kenntFeld.GibFeldPunktBreite / 2.8);
      zielYPosition := startYPosition;
    end;

    90: begin
      startYPosition := RoboterYPosition;
      startXPosition := RoboterXPosition - (kenntFeld.GibFeldPunktBreite / 4);
      zielXPosition := startXPosition;
      zielYPosition := startYPosition - (kenntFeld.GibFeldPunktTiefe / 2.8)
    end;

    270: begin
      startYPosition := RoboterYPosition;
      startXPosition := RoboterXPosition - (kenntFeld.GibFeldPunktBreite / 4);
      zielXPosition := startXPosition;
      zielYPosition := startYPosition + (kenntFeld.GibFeldPunktTiefe / 2.8)
    end;
  end;

  kenntCanvas.MoveTo(Round(startXPosition), Round(startYPosition));
  kenntCanvas.LineTo(Round(zielXPosition), Round(zielYPosition));


  case kenntFeld.GibRoboterBlickRichtung of
    0, 180: begin
      startYPosition := RoboterYPosition + (kenntFeld.GibFeldPunktTiefe / 4);
      zielYPosition := startYPosition;
    end;

    90, 270: begin
      startXPosition := RoboterXPosition + (kenntFeld.GibFeldPunktBreite / 4);
      zielXPosition := startXPosition;
    end;
  end;

  kenntCanvas.MoveTo(Round(startXPosition), Round(startYPosition));
  kenntCanvas.LineTo(Round(zielXPosition), Round(zielYPosition));

  kenntCanvas.Pen.Width := 1;
  //--Arme--

  //--Items im Rucksack--
  startXPosition := RoboterXPosition;
  startYPosition := RoboterYPosition;
  if length(self.hatRucksack) <> 0 then
  begin
    (hatRucksack[0] as TItem).zeichneDich(startXPosition - (kenntFeld.GibFeldPunktBreite / 8),
                                          startYPosition - (kenntFeld.GibFeldPunktTiefe / 8),
                                          startXPosition + (kenntFeld.GibFeldPunktBreite / 8),
                                          startYPosition + (kenntFeld.GibFeldPunktTiefe / 8));
  end;

  //--Items im Rucksack--

  StatusGeandert(kenntFeld.gibRoboterXPosition, kenntFeld.gibRoboterYPosition, kenntFeld.gibRoboterBlickRichtung, length(hatRucksack), vorneFrei, itemDa);
end;

//-------- itemDa (public) ---------------------------------------------
function TBender.itemDa : Boolean;
var
  tmpFeldPunkt : TFeldPunkt;
begin
  result := false; 
  tmpFeldPunkt := kenntFeld.gibFeldPunktAnRoboterPosition;
  if length(tmpFeldPunkt) > 0
    then result := (tmpFeldPunkt[0] is TItem);
end;

//-------- itemsImRuckSack (public) ------------------------------------
function TBender.itemsImRuckSack : Boolean;
begin
  result := (Length(hatRucksack) > 0)
end;

//-------- SchautNachLinks (public) ------------------------------------
function TBender.SchautNachLinks : Boolean;
begin
  result := (kenntFeld.GibRoboterBlickRichtung = 180);
end;

//-------- SchautNachOben (public) -------------------------------------
function TBender.SchautNachOben : Boolean;
begin
  result := (kenntFeld.GibRoboterBlickRichtung = 90);
end;

//-------- SchautNachRechts (public) -----------------------------------
function TBender.SchautNachRechts : Boolean;
begin
  result := (kenntFeld.GibRoboterBlickRichtung = 0);
end;

//-------- SchautNachUnten (public) ------------------------------------
function TBender.SchautNachUnten : Boolean;
begin
  result := (kenntFeld.GibRoboterBlickRichtung = 270);
end;

//-------- vorneFrei (public) ------------------------------------------
function TBender.vorneFrei : Boolean;
var
  tmpFeldPunkt : TFeldPunkt;
  XPosition, YPosition : Integer;
begin
  result := false;
  XPosition := kenntFeld.gibRoboterXPosition;
  YPosition := kenntFeld.gibRoboterYPosition;


  case kenntFeld.GibRoboterBlickRichtung of
    0: if XPosition <> kenntFeld.GibFeldBreite - 1 then
       begin
         tmpFeldPunkt := kenntFeld.gibFeldPunktAnPosition(XPosition + 1, YPosition);
         if length(tmpFeldPunkt) > 0 then
         begin
           if not (tmpFeldPunkt[0] is THindernis)
             then result := true;
         end
           else result := true;
       end;

    180: if XPosition <> 0 then
       begin
         tmpFeldPunkt := kenntFeld.gibFeldPunktAnPosition(XPosition - 1, YPosition);
         if length(tmpFeldPunkt) > 0 then
         begin
           if not (tmpFeldPunkt[0] is THindernis)
             then result := true;
         end
           else result := true;
       end;

    90: if YPosition <> 0 then
       begin
         tmpFeldPunkt := kenntFeld.gibFeldPunktAnPosition(XPosition, YPosition - 1);
         if length(tmpFeldPunkt) > 0 then
         begin
           if not (tmpFeldPunkt[0] is THindernis)
             then result := true;
         end
           else result := true;
       end;

    270: if YPosition <> kenntFeld.GibFeldTiefe - 1 then
       begin
         tmpFeldPunkt := kenntFeld.gibFeldPunktAnPosition(XPosition, YPosition + 1);
         if length(tmpFeldPunkt) > 0 then
         begin
           if not (tmpFeldPunkt[0] is THindernis)
             then result := true;
         end
           else result := true;
       end;
  end;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TBender.gibFrei;
begin
  //Hier Code einfgen.
end;

end.
