UNIT mTScanner;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mthilfstypen, dialogs, Sysutils, mtscannerautomat;

type
   TScanner = CLASS

     // weitere Attribute
     private
        hatScannerAutomat : TScannerAutomat;

     // weitere Methoden
     private
        function ersetzeZeilenumbruchDurchLeerzeichen (pEingabe: String) : String; virtual;
     public
        constructor init; virtual;
        function ScanneProgrammText (pProgrammtext: String) : TTokenListe; virtual;
        destructor gibFrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TScanner: Methodendefinition 
//+---------------------------------------------------------------------

//-------- ersetzeZeilenumbruchDurchLeerzeichen (private) --------------
function TScanner.ersetzeZeilenumbruchDurchLeerzeichen (pEingabe: String) : String;
begin
  result := '';
  while length(pEingabe) > 0 do
  begin
    if (Copy(pEingabe,1,2) = #13#10) or
       (Copy(pEingabe,1,2) = #10#13) then
    begin
      result := result + ' ';
      pEingabe := Copy(pEingabe,3,length(pEingabe) - 2);      
    end
    else
    begin
      result := result + Copy(pEingabe,1,1);
      pEingabe := Copy(pEingabe,2,length(pEingabe) - 1);
    end;
  end;

end;

//-------- init (public) -----------------------------------------------
constructor TScanner.init;
begin
  hatScannerAutomat := TScannerAutomat.init;
end;

//-------- ScanneProgrammText (public) ---------------------------------
function TScanner.ScanneProgrammText (pProgrammtext: String) : TTokenListe;
var
  tmpAusgabe : TToken;
  aktuelleEingabe : String;
begin
  pProgrammtext := pProgrammtext + #13#10;
  pProgrammtext := ersetzeZeilenumbruchDurchLeerzeichen(pProgrammtext);
  pProgrammtext := LowerCase(pProgrammtext);

  hatScannerAutomat.setzeZurueck;

  SetLength(result,0);
  while length(pProgrammtext) > 0 do
  begin
    aktuelleEingabe := Copy(pProgrammtext,1,pos(' ', pProgrammtext) - 1);

    tmpAusgabe := hatScannerAutomat.verarbeiteEingabe(aktuelleEingabe);

    if (tmpAusgabe[1] <> '') or (tmpAusgabe[2] <> '') then
    begin
      SetLength(result, length(result) + 1);
      result[length(result) - 1][1] := tmpAusgabe[1];
      result[length(result) - 1][2] := tmpAusgabe[2];
    end;

    pProgrammtext := Copy(pProgrammtext,pos(' ', pProgrammtext) + 1,length(pProgrammtext) - pos(' ', pProgrammtext));
  end;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TScanner.gibFrei;
begin
  //Hier Code einfgen.
end;

end.
